config/routes.rb
Rails.application.routes.draw do
  mount RailsAdmin::Engine => '/admin', as: 'rails_admin'
  get 'home/index'
  get 'challenges', to: 'challenges#index'
  get 'challenges/:id', to: 'challenges#show', as: :challenge
  get 'dashboard', to: 'dashboards#index'
  get 'profile', to: 'users#show', as: :profile

  post 'challenges/:id/join', to: 'challenges#join', as: :join_challenge

  resources :challenges do
    resources :feedbacks, only: [:create]
  end

  devise_for :users
  # Define your application routes per the DSL in https://guides.rubyonrails.org/routing.html

  # Defines the root path route ("/")
  # root "articles#index"
  root to: 'home#index'
end

app/models/application_record.rb
class ApplicationRecord < ActiveRecord::Base
  primary_abstract_class
end

app/models/badge.rb
class Badge < ApplicationRecord
    has_many :user_badges
  
    validates :name, presence: true
  end

app/models/challenge.rb
class Challenge < ApplicationRecord
    has_many :user_challenges
    has_many :leaderboards
    has_many :feedbacks
  
    validates :name, presence: true
  end
  

app/models/feedback.rb
class Feedback < ApplicationRecord
  belongs_to :user
  belongs_to :challenge

  validates :message, presence: true
end

app/models/leaderboard.rb
class Leaderboard < ApplicationRecord
  belongs_to :challenge
  belongs_to :user

  validates :rank, numericality: { only_integer: true, greater_than_or_equal_to: 1 }
end

app/models/notification.rb
class Notification < ApplicationRecord
  belongs_to :user

  validates :message, presence: true
end

app/models/user.rb
class User < ApplicationRecord
  # Include default devise modules. Others available are:
  # :confirmable, :lockable, :timeoutable, :trackable and :omniauthable
  has_many :user_challenges
  has_many :leaderboards
  has_many :user_badges
  has_many :notifications
  has_many :feedbacks
  has_one_attached :profile_picture

  devise :database_authenticatable, :registerable,
         :recoverable, :rememberable, :validatable

  validates_each :email do |record, attr, value|
    unless value.downcase.end_with?('@ait.ac.th')
      record.errors.add(attr, 'must be an AIT email')
    end
  end

  attribute :admin, :boolean, default: false
end

app/models/user_badge.rb
class UserBadge < ApplicationRecord
  belongs_to :user
  belongs_to :badge
end

app/models/user_challenge.rb
class UserChallenge < ApplicationRecord
  belongs_to :user
  belongs_to :challenge

  validates :points_earned, numericality: { greater_than_or_equal_to: 0 }

  # Method to update points
  def add_points(points)
    update(points_earned: points_earned + points)
  end
end

app/controllers/badges_controller.rb
class BadgesController < ApplicationController
    before_action :authenticate_user!
  
    def index
      @badges = Badge.all
    end
  
  end
  

app/controllers/challenges_controller.rb
class ChallengesController < ApplicationController
    before_action :authenticate_user!, only: [:show, :join]
  
    def index
        @challenges = Challenge.where("end_date > ?", DateTime.now)
    end    
  
    def show
      @challenge = Challenge.find(params[:id])
      @challenge.feedbacks = @challenge.feedbacks.includes(:user) # Load feedbacks with users
    end     

    def join
      challenge = Challenge.find(params[:id])
      user_challenge = current_user.user_challenges.create(
        challenge: challenge, 
        points_earned: 0
      )
      
      if user_challenge.persisted?
        redirect_to dashboard_path, notice: 'You have successfully joined the challenge!'
      else
        redirect_to challenge, alert: "There was an issue joining the challenge: #{user_challenge.errors.full_messages.to_sentence}"
      end
    end    
end

app/controllers/feedbacks_controller.rb
class FeedbacksController < ApplicationController
  before_action :authenticate_user!

  def create
    @challenge = Challenge.find(params[:challenge_id])
    @feedback = @challenge.feedbacks.new(feedback_params)
    @feedback.user = current_user

    if @feedback.save
      redirect_to challenge_path(@challenge), notice: 'Feedback submitted successfully.'
    else
      redirect_to challenge_path(@challenge), alert: 'Unable to submit feedback.'
    end
  end

  private

  def feedback_params
    params.require(:feedback).permit(:message)
  end
end

app/controllers/home_controller.rb
class HomeController < ApplicationController
  def index
    @challenges = Challenge.where("end_date > ?", DateTime.now)
  end
end

app/controllers/users_controller.rb
class UsersController < ApplicationController
    before_action :authenticate_user!
  
    def show
      @user = current_user
    end
  end
  

app/helpers/application_helper.rb
module ApplicationHelper
end

app/helpers/badges_helper.rb
module BadgesHelper
end

app/helpers/challenges_helper.rb
module ChallengesHelper
end

app/helpers/dashboards_helper.rb
module DashboardsHelper
end

app/helpers/feedbacks_helper.rb
module FeedbacksHelper
end

app/helpers/home_helper.rb
module HomeHelper
end

app/helpers/leaderboards_helper.rb
module LeaderboardsHelper
end

app/helpers/notifications_helper.rb
module NotificationsHelper
end

app/helpers/users_helper.rb
module UsersHelper
end

app/views/challenges/show.html.erb
<h1><%= @challenge.name %></h1>
<p><%= @challenge.description %></p>
<p><%= @challenge.detailed_description %></p>
<p>Ends on: <%= @challenge.end_date.strftime("%B %d, %Y") %></p>

<% unless current_user.user_challenges.exists?(challenge_id: @challenge.id) %>
  <%= button_to 'Join Challenge', join_challenge_path(@challenge), method: :post, class: 'btn btn-success' %>
<% end %>

<% if @challenge.feedbacks.any? %>
  <h3>Feedbacks:</h3>
  <ul>
    <% @challenge.feedbacks.each do |feedback| %>
      <li><strong><%= feedback.user.email %>:</strong> <%= feedback.message %></li>
    <% end %>
  </ul>
<% else %>
  <p>No feedbacks yet.</p>
<% end %>

<%= form_with(model: [ @challenge, Feedback.new ], local: true) do |form| %>
  <div>
    <%= form.label :message, "Your Feedback" %>
    <%= form.text_area :message %>
  </div>
  <%= form.submit "Submit Feedback", class: 'btn btn-primary' %>
<% end %>

<%= link_to 'Go Back Home', root_path, class: 'btn btn-primary' %>

app/views/users/show.html.erb
<h1>User Profile</h1>

<p>Email: <%= @user.email %></p>
<p>Profile Picture: <%= image_tag(@user.profile_picture, style: "max-width: 200px; max-height: 200px;") if @user.profile_picture.attached? %></p>
<p>Personal Information: <%= @user.personal_information %></p>

<%= link_to 'Edit Profile', edit_user_registration_path, class: 'btn btn-primary' %>
<%= link_to 'Back to Dashboard', dashboard_path, class: 'btn btn-secondary' %>